/*
 * BaseShapes_impl.cpp
 *
 *  Created on: Jun 18, 2010
 *      Author: crueger
 */

#include "Shapes/BaseShapes.hpp"
#include "Shapes/BaseShapes_impl.hpp"

#include "vector.hpp"

bool Sphere_impl::isInside(const Vector &point){
  return point.NormSquared()<=1;
}

Shape Sphere(){
  Shape::impl_ptr impl = Shape::impl_ptr(new Sphere_impl());
  return Shape(impl);
}

bool Cuboid_impl::isInside(const Vector &point){
  return point[0]<=1 && point[1]<=1 && point[2]<=1;
}

Shape Cuboid(){
  Shape::impl_ptr impl = Shape::impl_ptr(new Sphere_impl());
  return Shape(impl);
}
